/*
 * 2004-10-21 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.group.target;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.TreeItem;
import org.vivianj.eclipse.plugin.buildfile.data.target.Property;
import org.vivianj.eclipse.plugin.buildfile.group.RightGroup;
import org.vivianj.eclipse.plugin.buildfile.util.Resource;

/**
 * PropertyGroup ڴͲʾPropertyϢPanel
 */
public class PropertyGroup extends RightGroup {
	private Group group = null;

	private Property property = null;

	private Label l_name = null;

	private Label l_value = null;

	private Label l_location = null;

	private Label l_refid = null;

	private Label l_resource = null;

	private Label l_file = null;

	private Label l_environment = null;

	private Label l_classpath = null;

	private Label l_classpathref = null;

	private Label l_prefix = null;

	private Text t_name = null;

	private Text t_value = null;

	private Text t_location = null;

	private Text t_refid = null;

	private Text t_resource = null;

	private Text t_file = null;

	private Text t_environment = null;

	private Text t_classpath = null;

	private Text t_classpathref = null;

	private Text t_prefix = null;

	private Button b_create = null;

	private Button b_update = null;

	private Button b_delete = null;

	/**
	 * PropertyGroup
	 * 
	 * @param p_group
	 *            parent
	 * @param p_property
	 *            ҪʾProperty
	 * @param p_treeItem
	 *            PropertyӦڵ
	 */
	public PropertyGroup(Group p_group, Property p_property, TreeItem p_treeItem) {
		this.group = p_group;
		this.group.setText(Resource.getSource("property.label"));

		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;

		this.group.setLayout(gridLayout);
		this.group.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL
				| GridData.GRAB_VERTICAL));

		this.treeItem = p_treeItem;
		this.property = p_property;
	}

	/**
	 * ʾPropertyʾ
	 * 
	 * @param key
	 *            ʱҪĹؼ
	 */
	public void createPanel(String key) {

		this.createPanel();
		if (key.equals(RightGroup.UPDATE)) {

			//		°Ŧ
			this.b_update = new Button(this.group, SWT.LEFT);
			b_update.setText(Resource.getSource("pub.update"));
			b_update.addMouseListener(this);

			//		ɾŦ
			this.b_delete = new Button(this.group, SWT.LEFT);
			b_delete.setText(Resource.getSource("pub.delete"));
			b_delete.addMouseListener(this);
		}
		if (key.equals(RightGroup.CREATE)) {
			//µӽڵ㰴Ŧ
			this.b_create = new Button(this.group, SWT.LEFT);
			b_create.setText(Resource.getSource("pub.create"));
			b_create.addMouseListener(this);
		}
	}

	/**
	 * mouseDownϵİť¼
	 */
	public void mouseDown(MouseEvent me) {
		Button source = (Button) me.getSource();
		if (source == this.b_update | source == this.b_create) {
			Property property = new Property();
			property.setName(this.t_name.getText());
			property.setValue(this.t_value.getText());
			property.setLocation(this.t_location.getText());
			property.setRefid(this.t_refid.getText());
			property.setResource(this.t_resource.getText());
			property.setFile(this.t_file.getText());
			property.setEnvironment(this.t_environment.getText());
			property.setClasspath(this.t_classpath.getText());
			property.setClasspathref(this.t_classpathref.getText());
			property.setPrefix(this.t_prefix.getText());

			this.treeItem.setText(property.getName());
			this.treeItem.setData(property);
		} else if (source == this.b_delete) {
			this.treeItem.dispose();
		}
		this.group.getParent().layout();
		this.invokeSave();
	}

	/**
	 * ʾPropertyʾеLabelText
	 */
	public void createPanel() {
		this.l_name = this.createLabel(Resource.getSource("property.name"),
				this.group);
		this.t_name = this.createText(this.property.getName(), this.group);

		this.l_value = this.createLabel(Resource.getSource("property.value"),
				this.group);
		this.t_value = this.createText(this.property.getValue(), this.group);

		this.l_location = this.createLabel(Resource
				.getSource("property.location"), this.group);
		this.t_location = this.createText(this.property.getLocation(),
				this.group);

		this.l_refid = this.createLabel(Resource.getSource("property.refid"),
				this.group);
		this.t_refid = this.createText(this.property.getRefid(), this.group);

		this.l_resource = this.createLabel(Resource
				.getSource("property.resource"), this.group);
		this.t_resource = this.createText(this.property.getResource(),
				this.group);

		this.l_file = this.createLabel(Resource.getSource("property.file"),
				this.group);
		this.t_file = this.createText(this.property.getFile(), this.group);

		this.l_environment = this.createLabel(Resource
				.getSource("property.environment"), this.group);
		this.t_environment = this.createText(this.property.getEnvironment(),
				this.group);

		this.l_classpath = this.createLabel(Resource
				.getSource("property.classpath"), this.group);
		this.t_classpath = this.createText(this.property.getClasspath(),
				this.group);

		this.l_classpathref = this.createLabel(Resource
				.getSource("property.classpathref"), this.group);
		this.t_classpathref = this.createText(this.property.getClasspathref(),
				this.group);

		this.l_prefix = this.createLabel(Resource.getSource("property.prefix"),
				this.group);
		this.t_prefix = this.createText(this.property.getPrefix(), this.group);
	}

}