/*
 * 2004-10-21 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.group.target;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.TreeItem;
import org.vivianj.eclipse.plugin.buildfile.data.target.Target;
import org.vivianj.eclipse.plugin.buildfile.group.RightGroup;
import org.vivianj.eclipse.plugin.buildfile.util.Resource;

/**
 * TargetGroup ڴͲʾTargetϢPanel
 */
public class TargetGroup extends RightGroup {
	private Group group = null;

	private Target target = null;

	private Label l_name = null;

	private Label l_depends = null;

	private Label l_if = null;

	private Label l_unless = null;

	private Label l_description = null;

	private Text t_name = null;

	private Text t_depends = null;

	private Text t_if = null;

	private Text t_unless = null;

	private Text t_description = null;

	private Button b_create = null;

	private Button b_update = null;

	private Button b_delete = null;

	/**
	 * TargetGroup
	 * 
	 * @param p_group --
	 *            parent
	 * @param p_target --
	 *            Ӧʾtarget
	 * @param p_treeItem --
	 *            Ӧڵ
	 */
	public TargetGroup(Group p_group, Target p_target, TreeItem p_treeItem) {
		this.group = p_group;
		this.group.setText(Resource.getSource("target.label"));

		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;

		this.group.setLayout(gridLayout);
		this.group.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL
				| GridData.GRAB_VERTICAL));

		this.treeItem = p_treeItem;
		this.target = p_target;
	}

	public Button getB_create() {
		return b_create;
	}

	public void setB_create(Button b_create) {
		this.b_create = b_create;
	}

	public Button getB_delete() {
		return b_delete;
	}

	public void setB_delete(Button b_delete) {
		this.b_delete = b_delete;
	}

	public Button getB_update() {
		return b_update;
	}

	public void setB_update(Button b_update) {
		this.b_update = b_update;
	}

	public Composite getGroup() {
		return group;
	}

	public void setGroup(Group group) {
		this.group = group;
	}

	public Label getL_depends() {
		return l_depends;
	}

	public void setL_depends(Label l_depends) {
		this.l_depends = l_depends;
	}

	public Label getL_description() {
		return l_description;
	}

	public void setL_description(Label l_description) {
		this.l_description = l_description;
	}

	public Label getL_if() {
		return l_if;
	}

	public void setL_if(Label l_if) {
		this.l_if = l_if;
	}

	public Label getL_name() {
		return l_name;
	}

	public void setL_name(Label l_name) {
		this.l_name = l_name;
	}

	public Label getL_unless() {
		return l_unless;
	}

	public void setL_unless(Label l_unless) {
		this.l_unless = l_unless;
	}

	public Text getT_depends() {
		return t_depends;
	}

	public void setT_depends(Text t_depends) {
		this.t_depends = t_depends;
	}

	public Text getT_description() {
		return t_description;
	}

	public void setT_description(Text t_description) {
		this.t_description = t_description;
	}

	public Text getT_if() {
		return t_if;
	}

	public void setT_if(Text t_if) {
		this.t_if = t_if;
	}

	public Text getT_name() {
		return t_name;
	}

	public void setT_name(Text t_name) {
		this.t_name = t_name;
	}

	public Text getT_unless() {
		return t_unless;
	}

	public void setT_unless(Text t_unless) {
		this.t_unless = t_unless;
	}

	public Target getTarget() {
		return target;

	}

	public void setTarget(Target target) {
		this.target = target;
	}

	/**
	 * @param key --
	 *            panelĹؼ
	 */
	public void createPanel(String key) {

		this.createPanel();

		if (key.equals(RightGroup.UPDATE)) {

			//		°Ŧ
			this.b_update = new Button(this.group, SWT.LEFT);
			b_update.setText(Resource.getSource("pub.update"));
			b_update.addMouseListener(this);

			//		ɾŦ
			this.b_delete = new Button(this.group, SWT.LEFT);
			b_delete.setText(Resource.getSource("pub.delete"));
			b_delete.addMouseListener(this);
		}
		if (key.equals(RightGroup.CREATE)) {
			//µӽڵ㰴Ŧ
			this.b_create = new Button(this.group, SWT.LEFT);
			b_create.setText(Resource.getSource("pub.create"));
			b_create.addMouseListener(this);
		}
	}

	/**
	 * mouseDownϵİť¼
	 */
	public void mouseDown(MouseEvent me) {
		Button source = (Button) me.getSource();
		if (source == this.b_update || source == this.b_create) {
			Target target = new Target();
			target.setName(this.t_name.getText());
			target.setDepends(this.t_depends.getText());
			target.setIfAttribute(this.t_if.getText());
			target.setUnless(this.t_unless.getText());

			this.treeItem.setText(target.getName());
			this.treeItem.setData(target);
		} else if (source == this.b_delete) {
			this.treeItem.dispose();
		}
		this.group.getParent().layout();
		this.invokeSave();
	}

	/**
	 * ʾLabelText
	 */
	public void createPanel() {
		this.l_name = this.createLabel(Resource.getSource("target.name"),
				this.group);
		this.t_name = this.createText(this.target.getName(), this.group);

		this.l_depends = this.createLabel(Resource.getSource("target.depends"),
				this.group);
		this.t_depends = this.createText(this.target.getDepends(), this.group);

		this.l_if = this.createLabel(Resource.getSource("target.if"),
				this.group);
		this.t_if = this.createText(this.target.getIfAttribute(), this.group);

		this.l_unless = this.createLabel(Resource.getSource("target.unless"),
				this.group);
		this.t_unless = this.createText(this.target.getUnless(), this.group);

		this.l_description = this.createLabel(Resource
				.getSource("target.description"), this.group);
		this.t_description = this.createText(this.target.getDescription(),
				this.group);
	}
}