/*
 * 2004-10-22 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.core.runtime.IPluginDescriptor;
import org.eclipse.ui.plugin.AbstractUIPlugin;

/**
 * BuildFileDesignerPluginʵ˺EclipseĽӿ
 */
public class BuildFileDesignerPlugin extends AbstractUIPlugin {
	//BuildFileDesignerPluginʵ
	private static BuildFileDesignerPlugin plugin;
	//Դʶʵ
	private ResourceBundle resourceBundle;

	/**
	 * BuildFileDesignerPlugin
	 */
	public BuildFileDesignerPlugin(IPluginDescriptor descriptor) {
		super(descriptor);
		plugin = this;
		try {
			resourceBundle =
				ResourceBundle.getBundle(
					"org.vivianj.eclipse.plugin.buildfile.resource");
		} catch (MissingResourceException x) {
			resourceBundle = null;
		}
	}

	/**
	 * BuildFileDesignerPluginʵ
	 */
	public static BuildFileDesignerPlugin getDefault() {
		return plugin;
	}

	/**
	 * keyӦԴֵ
	 */
	public static String getResourceString(String key) {
		ResourceBundle bundle =
			BuildFileDesignerPlugin.getDefault().getResourceBundle();
		try {
			return (bundle != null) ? bundle.getString(key) : key;
		} catch (MissingResourceException e) {
			return key;
		}
	}

	/**
	 * Դʵ
	 */
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}
}
