/*
 * 2004-10-22 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.data;

import org.jdom.Element;
import org.vivianj.eclipse.plugin.buildfile.util.StringUtil;

/**
 * ProjectProject
 */
public class Project extends Data {
	private String defaultAttribute = "";

	private String baseDir = "";

	/**
	 * Project
	 */
	public Project() {
		this.setName("");
		this.defaultAttribute = "";
		this.baseDir = "";
	}

	/**
	 * Project
	 */
	public Project(Element element) {
		String p_name = element.getAttributeValue("name");
		String p_defaultTask = element.getAttributeValue("default");
		String p_baseDir = element.getAttributeValue("basedir");

		this.setName(p_name);
		this.setDefaultAttribute(p_defaultTask);
		this.setBaseDir(p_baseDir);
	}

	/**
	 * @return Projectbasedir
	 */
	public String getBaseDir() {
		return baseDir;
	}

	/**
	 * @param Projectbasedir
	 */
	public void setBaseDir(String baseDir) {
		this.baseDir = StringUtil.replaceNull(baseDir);
	}

	/**
	 * @return Projectdefault
	 */
	public String getDefaultAttribute() {
		return defaultAttribute;
	}

	/**
	 * @param Projectdefault
	 */
	public void setDefaultAttribute(String defaultAttribute) {
		this.defaultAttribute = StringUtil.replaceNull(defaultAttribute);
	}

	/**
	 * @return ProjectӦxmlԪصıǩ
	 */
	public String getOpenElement() {
		String result = "<project";
		if (!StringUtil.isNull(this.getName()))
			result = result + " name=\"" + this.getName() + "\"";
		if (!StringUtil.isNull(this.defaultAttribute))
			result = result + " default=\"" + this.defaultAttribute + "\"";
		if (!StringUtil.isNull(this.baseDir))
			result = result + " basedir=\"" + this.baseDir + "\"";
		;
		result = result + " >";
		return result;
	}

	/**
	 * @return ProjectӦxmlԪصĹرձǩ
	 */
	public String getCloseElement() {
		String result = "</project>";
		return result;
	}
}