/*
 * 2004-10-22 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.data.target;

import org.jdom.Element;
import org.vivianj.eclipse.plugin.buildfile.data.Data;
import org.vivianj.eclipse.plugin.buildfile.util.StringUtil;

/**
 * TargetTarget
 */
public class Target extends Data {
	private String depends = "";

	private String ifAttribute = "";

	private String unless = "";

	private String description = "";

	/**
	 * Target๹
	 */
	public Target() {
	}

	/**
	 * Target๹
	 */
	public Target(Element element) {
		String p_name = element.getAttributeValue("name");
		String p_depends = element.getAttributeValue("depends");
		String p_if = element.getAttributeValue("if");
		String p_unless = element.getAttributeValue("unless");
		String p_desciption = element.getAttributeValue("description");

		this.setName(p_name);
		this.setDepends(p_depends);
		this.setIfAttribute(p_if);
		this.setUnless(p_unless);
		this.setDescription(p_desciption);
	}

	/**
	 * @return Targetdepends
	 */
	public String getDepends() {
		return StringUtil.replaceNull(depends);
	}

	/**
	 * @param Targetdepends
	 */
	public void setDepends(String depends) {
		this.depends = StringUtil.replaceNull(depends);
	}

	/**
	 * @return Targetdescription
	 */
	public String getDescription() {
		return StringUtil.replaceNull(description);
	}

	/**
	 * @param Targetdescription
	 */
	public void setDescription(String description) {
		this.description = StringUtil.replaceNull(description);
	}

	/**
	 * @return Targetif
	 */
	public String getIfAttribute() {
		return StringUtil.replaceNull(ifAttribute);
	}

	/**
	 * @param Targetif
	 */
	public void setIfAttribute(String ifAttribute) {
		this.ifAttribute = StringUtil.replaceNull(ifAttribute);
	}

	/**
	 * @return Targetunless
	 */
	public String getUnless() {
		return StringUtil.replaceNull(unless);
	}

	/**
	 * @param Targetunless
	 */
	public void setUnless(String unless) {
		this.unless = StringUtil.replaceNull(unless);
	}

	/**
	 * @return TargetӦxmlԪصıǩ
	 */
	public String getOpenElement() {
		String result = "<target";
		if (!StringUtil.isNull(this.getName()))
			result = result + " name=\"" + this.getName() + "\"";
		if (!StringUtil.isNull(this.depends))
			result = result + " depends=\"" + this.depends + "\"";
		if (!StringUtil.isNull(this.ifAttribute))
			result = result + " if=\"" + this.ifAttribute + "\"";
		if (!StringUtil.isNull(this.unless))
			result = result + " unless=\"" + this.unless + "\"";
		if (!StringUtil.isNull(this.description))
			result = result + " description=\"" + this.description + "\"";
		result = result + " >";
		return result;
	}

	/**
	 * @return TargetӦxmlԪصĹرձǩ
	 */
	public String getCloseElement() {
		String result = "</target>";
		return result;
	}
}