/*
 * 2004-10-29 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.data.task;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.jdom.Attribute;
import org.jdom.Element;
import org.vivianj.eclipse.plugin.buildfile.data.Data;

/**
 * TaskTask
 */
public class Task extends Data {
	private HashMap properties = new HashMap();

	/**
	 * Task
	 */
	public Task() {

	}

	/**
	 * Task
	 */
	public Task(Element element) {
		this.setName(element.getName());
		List list = element.getAttributes();
		Iterator it = list.iterator();
		Attribute attribute;
		String property;
		String value;
		while (it.hasNext()) {
			attribute = (Attribute) it.next();
			property = attribute.getName();
			value = element.getAttributeValue(property);
			this.setProperty(property, value);
		}
	}

	/**
	 * setPropertyTaskֵ
	 * 
	 * @param key --
	 *            Task
	 * @param value --
	 *            Taskֵ
	 */
	public void setProperty(String key, String value) {
		String property = "";
		properties.remove(key);
		properties.put(key, value);
	}

	/**
	 * getPropertyTaskֵ
	 * 
	 * @param key --
	 *            Task
	 * @return Taskֵ
	 */
	public String getProperty(String key) {
		String property = "";
		property = (String) this.properties.get(key);
		if (property == null)
			property = "";
		return property;
	}

	/**
	 * @return ؿڵʾTask
	 */
	public String toString() {
		String result = "";
		result = (String) this.getName();
		if (result == null)
			result = "";
		return result;
	}

	/**
	 * @return TaskӦxmlԪصıǩ
	 */
	public String getOpenElement() {
		String result = "<" + this.getName();
		Set set = this.properties.keySet();
		Iterator it = set.iterator();
		while (it.hasNext()) {
			String property = (String) it.next();
			String value = this.getProperty(property);

			if (value == null || value.equals(""))
				;
			else
				result = result + " " + property + "=\"" + value + "\"";
		}
		result = result + " >";
		return result;
	}

	/**
	 * @return TaskӦxmlԪصĹرձǩ
	 */
	public String getCloseElement() {
		String result = "</" + this.getName() + ">";
		return result;
	}

}