/*
 * 2004-10-21 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.group;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.TreeItem;
import org.vivianj.eclipse.plugin.buildfile.data.Project;
import org.vivianj.eclipse.plugin.buildfile.util.Resource;

/**
 * ProjectGroup ڴͲʾProjectϢPanel
 */
public class ProjectGroup extends RightGroup {
	private Group group = null;

	private Project project = null;

	private Label l_name = null;

	private Label l_defaultAttribute = null;

	private Label l_baseDir = null;

	private Text t_name = null;

	private Text t_defaultAttribute = null;

	private Text t_baseDir = null;

	private Button b_create = null;

	private Button b_update = null;

	private Button b_delete = null;

	/**
	 * ProjectGroup
	 * 
	 * @param p_group --
	 *            parent
	 * @param p_project --
	 *            ӦʾProject
	 * @param p_treeItem --
	 *            Ӧڵ
	 */
	public ProjectGroup(Group p_group, Project p_project, TreeItem p_treeItem) {
		this.group = p_group;
		this.group.setText(Resource.getSource("project.label"));
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;

		this.group.setLayout(gridLayout);
		this.group.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL
				| GridData.GRAB_VERTICAL));

		this.treeItem = p_treeItem;
		this.project = p_project;
	}

	public Label getL_baseDir() {
		return l_baseDir;
	}

	public void setL_baseDir(Label dir) {
		l_baseDir = dir;
	}

	public Label getL_defaultAttribute() {
		return l_defaultAttribute;
	}

	public void setL_defaultAttribute(Label attribute) {
		l_defaultAttribute = attribute;
	}

	public Label getL_name() {
		return l_name;
	}

	public void setL_name(Label l_name) {
		this.l_name = l_name;
	}

	public Text getT_baseDir() {
		return t_baseDir;
	}

	public void setT_baseDir(Text dir) {
		t_baseDir = dir;
	}

	public Text getT_defaultAttribute() {
		return t_defaultAttribute;
	}

	public void setT_defaultAttribute(Text attribute) {
		t_defaultAttribute = attribute;
	}

	public Text getT_name() {
		return t_name;
	}

	public void setT_name(Text t_name) {
		this.t_name = t_name;
	}

	/**
	 * @param key --
	 *            panelĹؼ
	 */
	public void createPanel(String key) {

		//		ǩ
		this.l_name = this.createLabel(Resource.getSource("project.name"),
				this.group);
		//		
		this.t_name = this.createText(project.getName(), this.group);

		//		Ĭtargetǩ
		this.l_defaultAttribute = this.createLabel(Resource
				.getSource("project.default"), this.group);
		//		Ĭtarget
		//		Ŀǰ汾ѡ
		this.t_defaultAttribute = this.createText(
				project.getDefaultAttribute(), this.group);

		//		basedirǩ
		this.l_baseDir = this.createLabel(
				Resource.getSource("project.basedir"), this.group);
		//		basedir
		this.t_baseDir = this.createText(project.getBaseDir(), this.group);

		//		°Ŧ
		if (key.equals(RightGroup.UPDATE)) {
			this.b_update = new Button(this.group, SWT.LEFT);
			b_update.setText(Resource.getSource("pub.update"));

			b_update.addMouseListener(this);
		}

	}

	/**
	 * mouseDownϵİť¼
	 */
	public void mouseDown(MouseEvent me) {
		Project project = new Project();
		project.setName(this.t_name.getText());
		project.setDefaultAttribute(this.t_defaultAttribute.getText());
		project.setBaseDir(this.t_baseDir.getText());

		this.treeItem.setText(project.getName());
		this.treeItem.setData(project);

		this.invokeSave();
	}

}